Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIManagerDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIManagerDefs.h	(revision 83921)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIManagerDefs.h	(revision 83921)
@@ -0,0 +1,43 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIVirtualBoxManager definitions.
+ */
+
+/*
+ * Copyright (C) 2020 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef FEQT_INCLUDED_SRC_manager_UIChooserDefs_h
+#define FEQT_INCLUDED_SRC_manager_UIChooserDefs_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+
+/** Virtual machine item types. */
+enum UIVirtualMachineItemType
+{
+    UIVirtualMachineItemType_Local,
+    UIVirtualMachineItemType_CloudFake,
+    UIVirtualMachineItemType_CloudReal
+};
+
+
+/** Fake cloud virtual machine item states. */
+enum UIFakeCloudVirtualMachineItemState
+{
+    UIFakeCloudVirtualMachineItemState_NotApplicable,
+    UIFakeCloudVirtualMachineItemState_Loading,
+    UIFakeCloudVirtualMachineItemState_Done
+};
+
+
+#endif /* !FEQT_INCLUDED_SRC_manager_UIChooserDefs_h */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 83921)
@@ -575,5 +575,5 @@
 
     /* For local machine: */
-    if (pItem->itemType() == UIVirtualMachineItem::ItemType_Local)
+    if (pItem->itemType() == UIVirtualMachineItemType_Local)
     {
         /* Open add machine dialog: */
@@ -958,5 +958,5 @@
     {
         /* For local machine: */
-        if (pItem->itemType() == UIVirtualMachineItem::ItemType_Local)
+        if (pItem->itemType() == UIVirtualMachineItemType_Local)
         {
             /* Open a session to modify VM state: */
@@ -976,5 +976,5 @@
         }
         /* For real cloud machine: */
-        else if (pItem->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+        else if (pItem->itemType() == UIVirtualMachineItemType_CloudReal)
         {
             /* Acquire cloud machine: */
@@ -1024,5 +1024,5 @@
     {
         /* For local machine: */
-        if (pItem->itemType() == UIVirtualMachineItem::ItemType_Local)
+        if (pItem->itemType() == UIVirtualMachineItemType_Local)
         {
             /* Open a session to modify VM state: */
@@ -1049,5 +1049,5 @@
         }
         /* For real cloud machine: */
-        else if (pItem->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+        else if (pItem->itemType() == UIVirtualMachineItemType_CloudReal)
         {
             /* Acquire cloud machine: */
@@ -1694,5 +1694,5 @@
         {
             /* For local machine: */
-            if (pItem->itemType() == UIVirtualMachineItem::ItemType_Local)
+            if (pItem->itemType() == UIVirtualMachineItemType_Local)
             {
                 /* Fetch item launch mode: */
@@ -1710,5 +1710,5 @@
             }
             /* For real cloud machine: */
-            else if (pItem->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+            else if (pItem->itemType() == UIVirtualMachineItemType_CloudReal)
             {
                 /* Acquire cloud machine: */
@@ -2144,5 +2144,5 @@
 
         /* For local machine: */
-        if (pItem->itemType() == UIVirtualMachineItem::ItemType_Local)
+        if (pItem->itemType() == UIVirtualMachineItemType_Local)
         {
             /* Skip session failures: */
@@ -2167,5 +2167,5 @@
         }
         /* For real cloud machine: */
-        else if (pItem->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+        else if (pItem->itemType() == UIVirtualMachineItemType_CloudReal)
         {
             /* Running cloud VM has it by definition: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 83921)
@@ -812,5 +812,5 @@
     /* Update machine tools restrictions: */
     QList<UIToolType> retrictedTypes;
-    if (pItem && pItem->itemType() != UIVirtualMachineItem::ItemType_Local)
+    if (pItem && pItem->itemType() != UIVirtualMachineItemType_Local)
     {
         retrictedTypes << UIToolType_Snapshots << UIToolType_Logs;
@@ -835,8 +835,8 @@
         m_pPaneToolsMachine->setItems(currentItems());
         /* Propagate current machine to update the Snapshots-pane or/and Logviewer-pane: */
-        if (pItem->itemType() == UIVirtualMachineItem::ItemType_Local)
+        if (pItem->itemType() == UIVirtualMachineItemType_Local)
             m_pPaneToolsMachine->setMachine(pItem->toLocal()->machine());
         /* Update current cloud machine state: */
-        if (pItem->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+        if (pItem->itemType() == UIVirtualMachineItemType_CloudReal)
             pItem->toCloud()->updateInfoAsync(false /* delayed? */);
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.cpp	(revision 83921)
@@ -25,5 +25,5 @@
 *********************************************************************************************************************************/
 
-UIVirtualMachineItem::UIVirtualMachineItem(ItemType enmType)
+UIVirtualMachineItem::UIVirtualMachineItem(UIVirtualMachineItemType enmType)
     : m_enmType(enmType)
     , m_fAccessible(false)
@@ -40,5 +40,5 @@
 UIVirtualMachineItemLocal *UIVirtualMachineItem::toLocal()
 {
-    return   itemType() == ItemType_Local
+    return   itemType() == UIVirtualMachineItemType_Local
            ? static_cast<UIVirtualMachineItemLocal*>(this)
            : 0;
@@ -47,6 +47,6 @@
 UIVirtualMachineItemCloud *UIVirtualMachineItem::toCloud()
 {
-    return   (   itemType() == ItemType_CloudFake
-              || itemType() == ItemType_CloudReal)
+    return   (   itemType() == UIVirtualMachineItemType_CloudFake
+              || itemType() == UIVirtualMachineItemType_CloudReal)
            ? static_cast<UIVirtualMachineItemCloud*>(this)
            : 0;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.h	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItem.h	(revision 83921)
@@ -30,4 +30,5 @@
 /* GUI includes: */
 #include "QIWithRetranslateUI.h"
+#include "UIManagerDefs.h"
 #include "UISettingsDefs.h"
 
@@ -46,9 +47,6 @@
 public:
 
-    /** Item types. */
-    enum ItemType { ItemType_Local, ItemType_CloudFake, ItemType_CloudReal };
-
     /** Constructs VM item on the basis of taken @a enmType. */
-    UIVirtualMachineItem(ItemType enmType);
+    UIVirtualMachineItem(UIVirtualMachineItemType enmType);
     /** Destructs VM item. */
     virtual ~UIVirtualMachineItem();
@@ -57,5 +55,5 @@
       * @{ */
         /** Returns item type. */
-        ItemType itemType() const { return m_enmType; }
+        UIVirtualMachineItemType itemType() const { return m_enmType; }
         /** Returns item casted to local type. */
         UIVirtualMachineItemLocal *toLocal();
@@ -145,5 +143,5 @@
       * @{ */
         /** Holds item type. */
-        ItemType  m_enmType;
+        UIVirtualMachineItemType  m_enmType;
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp	(revision 83921)
@@ -36,6 +36,6 @@
 
 UIVirtualMachineItemCloud::UIVirtualMachineItemCloud()
-    : UIVirtualMachineItem(ItemType_CloudFake)
-    , m_enmFakeCloudItemState(FakeCloudItemState_Loading)
+    : UIVirtualMachineItem(UIVirtualMachineItemType_CloudFake)
+    , m_enmFakeCloudItemState(UIFakeCloudVirtualMachineItemState_Loading)
     , m_pTask(0)
 {
@@ -44,7 +44,7 @@
 
 UIVirtualMachineItemCloud::UIVirtualMachineItemCloud(const CCloudMachine &comCloudMachine)
-    : UIVirtualMachineItem(ItemType_CloudReal)
+    : UIVirtualMachineItem(UIVirtualMachineItemType_CloudReal)
     , m_comCloudMachine(comCloudMachine)
-    , m_enmFakeCloudItemState(FakeCloudItemState_NotApplicable)
+    , m_enmFakeCloudItemState(UIFakeCloudVirtualMachineItemState_NotApplicable)
     , m_pTask(0)
 {
@@ -92,12 +92,12 @@
                       : KMachineState_PoweredOff;
     m_strMachineStateName = gpConverter->toString(m_enmMachineState);
-    if (itemType() == ItemType_CloudFake)
+    if (itemType() == UIVirtualMachineItemType_CloudFake)
     {
         switch (m_enmFakeCloudItemState)
         {
-            case UIVirtualMachineItemCloud::FakeCloudItemState_Loading:
+            case UIFakeCloudVirtualMachineItemState_Loading:
                 m_machineStateIcon = UIIconPool::iconSet(":/state_loading_16px.png");
                 break;
-            case UIVirtualMachineItemCloud::FakeCloudItemState_Done:
+            case UIFakeCloudVirtualMachineItemState_Done:
                 m_machineStateIcon = UIIconPool::iconSet(":/vm_new_16px.png");
                 break;
@@ -125,6 +125,6 @@
 {
     /* We are using icon corresponding to cached guest OS type: */
-    if (   itemType() == ItemType_CloudFake
-        && fakeCloudItemState() == FakeCloudItemState_Loading)
+    if (   itemType() == UIVirtualMachineItemType_CloudFake
+        && fakeCloudItemState() == UIFakeCloudVirtualMachineItemState_Loading)
         m_pixmap = uiCommon().vmGuestOSTypePixmapDefault("Cloud", &m_logicalPixmapSize);
     else
@@ -194,13 +194,13 @@
     if (accessible())
     {
-        if (itemType() == ItemType_CloudFake)
+        if (itemType() == UIVirtualMachineItemType_CloudFake)
         {
             /* Update machine/state name: */
             switch (m_enmFakeCloudItemState)
             {
-                case UIVirtualMachineItemCloud::FakeCloudItemState_Loading:
+                case UIFakeCloudVirtualMachineItemState_Loading:
                     m_strMachineStateName = tr("Loading ...");
                     break;
-                case UIVirtualMachineItemCloud::FakeCloudItemState_Done:
+                case UIFakeCloudVirtualMachineItemState_Done:
                     m_strMachineStateName = tr("Empty");
                     break;
@@ -239,5 +239,5 @@
 {
     /* Make sure item is of real cloud type and is initialized: */
-    AssertReturnVoid(itemType() == ItemType_CloudReal);
+    AssertReturnVoid(itemType() == UIVirtualMachineItemType_CloudReal);
 
     /* Create and start task to acquire info async way only if there is no task yet: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h	(revision 83921)
@@ -44,12 +44,4 @@
 public:
 
-    /** Fake cloud item states. */
-    enum FakeCloudItemState
-    {
-        FakeCloudItemState_NotApplicable,
-        FakeCloudItemState_Loading,
-        FakeCloudItemState_Done
-    };
-
     /** Constructs fake cloud VM item. */
     UIVirtualMachineItemCloud();
@@ -68,7 +60,7 @@
       * @{ */
         /** Defines fake cloud item @a enmState. */
-        void setFakeCloudItemState(FakeCloudItemState enmState) { m_enmFakeCloudItemState = enmState; }
+        void setFakeCloudItemState(UIFakeCloudVirtualMachineItemState enmState) { m_enmFakeCloudItemState = enmState; }
         /** Returns fake cloud item state. */
-        FakeCloudItemState fakeCloudItemState() const { return m_enmFakeCloudItemState; }
+        UIFakeCloudVirtualMachineItemState fakeCloudItemState() const { return m_enmFakeCloudItemState; }
 
         /** Updates cloud VM info async way, @a fDelayed if requested or instant otherwise. */
@@ -132,5 +124,5 @@
       * @{ */
         /** Holds fake cloud item state. */
-        FakeCloudItemState  m_enmFakeCloudItemState;
+        UIFakeCloudVirtualMachineItemState  m_enmFakeCloudItemState;
 
         /** Holds the info acquire task instance. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemLocal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemLocal.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemLocal.cpp	(revision 83921)
@@ -40,5 +40,5 @@
 
 UIVirtualMachineItemLocal::UIVirtualMachineItemLocal(const CMachine &comMachine)
-    : UIVirtualMachineItem(ItemType_Local)
+    : UIVirtualMachineItem(UIVirtualMachineItemType_Local)
     , m_comMachine(comMachine)
     , m_cSnaphot(0)
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 83921)
@@ -441,6 +441,6 @@
                                                                            false /* favorite */,
                                                                            0 /* position */);
-                pFakeNode->toMachineNode()->cache()->toCloud()->setFakeCloudItemState(UIVirtualMachineItemCloud::FakeCloudItemState_Done);
-                pFakeNode->toMachineNode()->cache()->toCloud()->recache();
+                pFakeNode->cache()->toCloud()->setFakeCloudItemState(UIFakeCloudVirtualMachineItemState_Done);
+                pFakeNode->cache()->toCloud()->recache();
             }
             /* Remove fake cloud VM item otherwise: */
@@ -520,5 +520,5 @@
     AssertPtrReturnVoid(pFirstChildNodeMachine);
     AssertPtrReturnVoid(pFirstChildNodeMachine->cache());
-    AssertReturnVoid(pFirstChildNodeMachine->cache()->itemType() == UIVirtualMachineItem::ItemType_CloudFake);
+    AssertReturnVoid(pFirstChildNodeMachine->cache()->itemType() == UIVirtualMachineItemType_CloudFake);
 
     /* And if we have at least one cloud machine: */
@@ -538,5 +538,5 @@
         UIVirtualMachineItemCloud *pFakeCloudMachineItem = pFirstChildNodeMachine->cache()->toCloud();
         AssertPtrReturnVoid(pFakeCloudMachineItem);
-        pFakeCloudMachineItem->setFakeCloudItemState(UIVirtualMachineItemCloud::FakeCloudItemState_Done);
+        pFakeCloudMachineItem->setFakeCloudItemState(UIFakeCloudVirtualMachineItemState_Done);
         pFakeCloudMachineItem->recache();
     }
@@ -979,5 +979,5 @@
     foreach (UIChooserNode *pNode, pParentGroup->nodes(UIChooserNodeType_Machine))
         if (UIChooserNodeMachine *pMachineNode = pNode->toMachineNode())
-            if (   pMachineNode->cache()->itemType() == UIVirtualMachineItem::ItemType_Local
+            if (   pMachineNode->cache()->itemType() == UIVirtualMachineItemType_Local
                 && pMachineNode->cache()->accessible())
                 definitions[toOldStyleUuid(pMachineNode->cache()->id())] << pParentGroup->fullName();
@@ -1008,6 +1008,6 @@
     foreach (UIChooserNode *pNode, pParentGroup->nodes(UIChooserNodeType_Machine))
         if (UIChooserNodeMachine *pMachineNode = pNode->toMachineNode())
-            if (   pMachineNode->cache()->itemType() == UIVirtualMachineItem::ItemType_Local
-                || pMachineNode->cache()->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+            if (   pMachineNode->cache()->itemType() == UIVirtualMachineItemType_Local
+                || pMachineNode->cache()->itemType() == UIVirtualMachineItemType_CloudReal)
                 orders[strExtraDataKey] << QString("m=%1").arg(toOldStyleUuid(pMachineNode->cache()->id()));
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 83921)
@@ -726,5 +726,5 @@
         /* For local items: */
         if (   node()->toGroupNode()->groupType() == UIChooserNodeGroupType_Local
-            && pMachineItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItem::ItemType_Local)
+            && pMachineItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItemType_Local)
         {
             /* Make sure passed machine isn't immutable within own group: */
@@ -751,5 +751,5 @@
         else
         if (   node()->toGroupNode()->groupType() == UIChooserNodeGroupType_Profile
-            && pMachineItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+            && pMachineItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItemType_CloudReal)
         {
             /* Make sure passed item is ours: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 83921)
@@ -297,5 +297,5 @@
     /* And machine-item content to take into account: */
     int iTopLineWidth = m_iMinimumNameWidth;
-    if (   node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItem::ItemType_Local
+    if (   node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItemType_Local
         && !node()->toMachineNode()->cache()->toLocal()->snapshotName().isEmpty())
         iTopLineWidth += (iMinorSpacing +
@@ -395,6 +395,6 @@
 
         /* No drops for cloud items: */
-        if (   node()->toMachineNode()->cache()->itemType() != UIVirtualMachineItem::ItemType_Local
-            || pMachineItem->node()->toMachineNode()->cache()->itemType() != UIVirtualMachineItem::ItemType_Local)
+        if (   node()->toMachineNode()->cache()->itemType() != UIVirtualMachineItemType_Local
+            || pMachineItem->node()->toMachineNode()->cache()->itemType() != UIVirtualMachineItemType_Local)
             return false;
         /* No drops for immutable item: */
@@ -721,5 +721,5 @@
     int iMinimumSnapshotNameWidth = 0;
     /* Is there any snapshot exists? */
-    if (   node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItem::ItemType_Local
+    if (   node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItemType_Local
         && !node()->toMachineNode()->cache()->toLocal()->snapshotName().isEmpty())
     {
@@ -807,5 +807,5 @@
 {
     /* Make sure this is local machine item: */
-    if (node()->toMachineNode()->cache()->itemType() != UIVirtualMachineItem::ItemType_Local)
+    if (node()->toMachineNode()->cache()->itemType() != UIVirtualMachineItemType_Local)
         return;
 
@@ -1113,5 +1113,5 @@
 
             /* Paint middle element: */
-            if (   node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItem::ItemType_Local
+            if (   node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItemType_Local
                 && !node()->toMachineNode()->cache()->toLocal()->snapshotName().isEmpty())
             {
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 83921)
@@ -920,5 +920,5 @@
     /* What first item do we have? */
     if (  !firstSelectedMachineItem()
-        ||firstSelectedMachineItem()->itemType() == UIVirtualMachineItem::ItemType_Local)
+        ||firstSelectedMachineItem()->itemType() == UIVirtualMachineItemType_Local)
     {
         /* Select the parent: */
@@ -1058,5 +1058,5 @@
         switch (pItem->node()->toMachineNode()->cache()->itemType())
         {
-            case UIVirtualMachineItem::ItemType_Local:
+            case UIVirtualMachineItemType_Local:
             {
                 /* Recache: */
@@ -1079,5 +1079,5 @@
                 break;
             }
-            case UIVirtualMachineItem::ItemType_CloudReal:
+            case UIVirtualMachineItemType_CloudReal:
             {
                 /* Much more simple than for local items, we are not reloading them, just refreshing: */
@@ -1150,7 +1150,7 @@
         if (fVerdict)
         {
-            if (pItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItem::ItemType_Local)
+            if (pItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItemType_Local)
                 localMachinesToUnregister.append(pItem->node()->toMachineNode()->cache()->toLocal()->machine());
-            else if (pItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+            else if (pItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItemType_CloudReal)
                 cloudMachinesToUnregister.append(pItem->node()->toMachineNode()->cache()->toCloud()->machine());
         }
@@ -1739,5 +1739,5 @@
                                                      UIChooserItemSearchFlag_ExactId);
         AssertPtrReturnVoid(pItem);
-        AssertReturnVoid(pItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItem::ItemType_CloudReal);
+        AssertReturnVoid(pItem->node()->toMachineNode()->cache()->itemType() == UIVirtualMachineItemType_CloudReal);
         AssertPtrReturnVoid(pItem->parentItem());
         AssertPtrReturnVoid(pItem->parentItem()->parentItem());
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp	(revision 83921)
@@ -81,11 +81,11 @@
     switch (pCopyFrom->cache()->itemType())
     {
-        case UIVirtualMachineItem::ItemType_Local:
+        case UIVirtualMachineItemType_Local:
             m_pCache = new UIVirtualMachineItemLocal(pCopyFrom->cache()->toLocal()->machine());
             break;
-        case UIVirtualMachineItem::ItemType_CloudFake:
+        case UIVirtualMachineItemType_CloudFake:
             m_pCache = new UIVirtualMachineItemCloud;
             break;
-        case UIVirtualMachineItem::ItemType_CloudReal:
+        case UIVirtualMachineItemType_CloudReal:
             m_pCache = new UIVirtualMachineItemCloud(pCopyFrom->cache()->toCloud()->machine());
             break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.cpp	(revision 83921)
@@ -81,6 +81,6 @@
     QList<UIVirtualMachineItem*> filteredItems;
     foreach (UIVirtualMachineItem *pItem, machineItems)
-        if (   pItem->itemType() == UIVirtualMachineItem::ItemType_Local
-            || pItem->itemType() == UIVirtualMachineItem::ItemType_CloudReal)
+        if (   pItem->itemType() == UIVirtualMachineItemType_Local
+            || pItem->itemType() == UIVirtualMachineItemType_CloudReal)
             filteredItems << pItem;
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsSet.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsSet.cpp	(revision 83920)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsSet.cpp	(revision 83921)
@@ -68,5 +68,5 @@
     /* Remember passed arguments: */
     m_pMachineItem = pMachineItem;
-    m_fIsLocal = m_pMachineItem->itemType() == UIVirtualMachineItem::ItemType_Local;
+    m_fIsLocal = m_pMachineItem->itemType() == UIVirtualMachineItemType_Local;
     m_fHasDetails = m_pMachineItem->hasDetails();
     m_fFullSet = fFullSet;
@@ -82,5 +82,5 @@
         switch (m_pMachineItem->itemType())
         {
-            case UIVirtualMachineItem::ItemType_Local:
+            case UIVirtualMachineItemType_Local:
             {
                 /* Get local machine: */
@@ -103,5 +103,5 @@
                 break;
             }
-            case UIVirtualMachineItem::ItemType_CloudReal:
+            case UIVirtualMachineItemType_CloudReal:
             {
                 /* Get cloud machine: */